/*  DETERMINE PLAN VIEW CONDITIONS IF NOT IN MEDIAN */


if median width > 50 then
  {
            /*  INITIALIZE VARIABLES  */
     mark x1 y1
     set skew angle 0
     _s_driveway = ^no^
     _s_sidewalk = ^No^
     _s_bikeway = ^No^
     _s_Front_Path = ^no^ 
     _s_Back_Path = ^no^ 
     _s_Path_tie = ^no^ 
     _s_HingePoint = ^no^
     _s_Mow_Strip = ^No^
            
     if intersect dgn = "~HP" then
        {
          _s_HingePoint = ^yes^
          draw skip dx = 1 dy = 0 to "~HP"
          mark x330 y330
          draw skip to x1 y1
        }
     
        /*  CHECK TO SEE IF SIDEWALK ELEMENTS ARE PRESENT  */
        
     if intersect dgn = "~FW" then
        {
          _s_Front_Path = ^Yes^ 
          draw skip dx=1 dy=0 to "~FW"
          mark x300 y300
          draw skip to x1 y1
          _s_sidewalk = ^Yes^
        }
      if intersect dgn = "~BW" then
        {
          _s_Back_Path = ^yes^ 
          draw skip dx=1 dy=0 to "~BW"
          mark x301 y301
          draw skip to x1 y1
          _s_sidewalk = ^Yes^
        }  
      if intersect dgn = "~SWT" then
        {
          _s_Path_tie = ^yes^
          draw skip dx=1 dy=0 to "~SWT"
          mark x305 y305
          draw skip to x1 y1
          _s_sidewalk = ^Yes^
        }  
         
       /*  CHECK TO SEE IF BIKEWAY ELEMENTS ARE PRESENT  */
        
     if intersect dgn = "~FBW" then
        {
          _s_Front_Path = ^Yes^
          draw skip dx=1 dy=0 to "~FBW"
          mark x300 y300
          draw skip to x1 y1
          _s_bikeway = ^Yes^
        }
      if intersect dgn = "~BBW" then
        {
          _s_Back_Path = ^yes^
          draw skip dx=1 dy=0 to "~BBW"
          mark x301 y301
          draw skip to x1 y1
          _s_bikeway = ^Yes^
        }  
      if intersect dgn = "~BWT" then
        {
          _s_Path_tie = ^yes^
          draw skip dx=1 dy=0 to "~SWT"
          mark x305 y305
          draw skip to x1 y1
          _s_bikeway = ^Yes^
        }  
     
     /*  SET THE THICKNESS FOR THE SIDEWALK OR BIKEWAY THICKNESS  */
        
     if _s_sidewalk = ^yes^ then
        {
          _d_Path_thickness = "sidewalk thickness"
        }
     else
        {
          _d_Path_thickness = "bikeway thickness"
        }  
     
     /*  CHECK TO SEE IF THE FORESLOPE AND OR BACKSLOPE STANDARDS HAVE BEEN OVERRIDDEN  */
     if p1 then
       {
         if intersect dgn = "~10_bs" then
            {
              _d_backslope = 10
            }
            
         else if intersect dgn = "~9_bs" then
            {
              _d_backslope = 9
            }
       
         else if intersect dgn = "~8_bs" then
            {
              _d_backslope = 8
            }
            
         else if intersect dgn = "~7_bs" then
            {
              _d_backslope = 7
            }    
                
         else if intersect dgn = "~6_bs" then
            {
              _d_backslope = 6
            }
            
         else if intersect dgn = "~5_bs" then
            {
              _d_backslope = 5
            }
       
         else if intersect dgn = "~4_bs" then
            {
              _d_backslope = 4
            }
                   
         else if intersect dgn = "~3_bs" then
            {
              _d_backslope = 3
            }    
                
         else if intersect dgn = "~2_bs" then
            {
              _d_backslope = 2
            }
            
         else if intersect dgn = "~1_bs" then
            {
              _d_backslope = 1
            }    
         else 
            {
              _d_backslope = "standard backslope (X:1)"
            }           
            
          /*   GRADING LINES - FORE SLOPE LINES   */         
            
         if intersect dgn = "~10_fs" then
            {
              _d_foreslope = 10
            }
            
         else if intersect dgn = "~9_fs" then
            {
              _d_foreslope = 9
            }
       
         else if intersect dgn = "~8_fs" then
            {
              _d_foreslope = 8
            }
            
         else if intersect dgn = "~7_fs" then
            {
              _d_foreslope = 7
            }    
                
         else if intersect dgn = "~6_fs" then
            {
              _d_foreslope = 6
            }
            
         else if intersect dgn = "~5_fs" then
            {
              _d_foreslope = 5
            }
       
         else if intersect dgn = "~4_fs" then
            {
              _d_foreslope = 4
            }
            
         else if intersect dgn = "~3_fs" then
            {
              _d_foreslope = 3
            }    
                
         else if intersect dgn = "~2_fs" then
            {
              _d_foreslope = 2
            }
            
         else if intersect dgn = "~1_fs" then
            {
              _d_foreslope = 1
            }
         else
            {
              _d_foreslope = "standard foreslope (X:-1)"
            }
         
       }
     if p1 then
       {
         mark x345 y345
         if intersect dgn = "~EOAD" then
           {
             _s_driveway = ^Asphalt^
             _d_driveway_thickness = "asph drive thickness"
             draw skip dx=1 dy=0 to "~EOAD"
             mark x600 y600
           }
         else if intersect dgn = "~EOCD" then
           {
             _s_driveway = ^Concrete^
             _d_driveway_thickness = "Conc drive thickness"
             draw skip dx=1 dy=0 to "~EOCD"
             mark x600 y600
           } 
         else if intersect dgn = "~EOUD" then
           {
             _s_driveway = ^Unpaved^
             _d_driveway_thickness = 0
             draw skip dx=1 dy=0 to "~EOUD"
             mark x600 y600
           } 
         else
           {
             _s_driveway = ^no^
           }
         draw skip to x345 y345  
       }
              
}


