/* Draws the Driveway profile

WRITTEN: May, 2003

Point range  600-649

1   driveway at back of curb
2   bottom of driveway at back of curb

600 driveway tie down from plan view
602 driveway at front of sidewalk
604 driveway at back of sidewalk
606 driveway tie down from plan view


=================================================================================================*/



if not _s_driveway = ^no^ then
  {
    mark x1 y1
    draw skip dx=0 dy=-_d_driveway_thickness
    mark x2 y2
    draw skip to x1 y1
    
     
    /*  DETERMINE SIDWALK CONDITION    */
    
    if _s_Sidewalk_case = ^Back Only^ then     /* ONLY BACK PRESENT  */
      {
        draw text char = ^Need to draw FRONT OF SIDEWALK through drive in plan view^  "~message text symbology"
      }
    else if _s_Sidewalk_case = ^Front Only^ then  /* ONLY FRONT PRESENT  */
      {
        draw text char = ^Need to draw BACK OF SIDEWALK through drive in plan view^  "~message text symbology"
      }
    else if _s_Sidewalk_case = ^Front & Back^ then
      {
        draw skip dx=0 dy=4/12
        draw skip slope = "Green Space Slope" to "~FW"
        mark x602 y602
        draw text char = ^SWF^ "~search text symbology"
        draw skip dx=0 dy=-_d_driveway_thickness
        mark x603 y603
        draw skip to x602 y602
        draw skip slope = "Sidewalk Slope" to "~BW"
        draw text char = ^SWB^ "~search text symbology"
        mark x604 y604
        draw skip dx=0 dy=-_d_driveway_thickness
        mark x605 y605
        draw skip to x604 y604
        draw skip dx=1 dy=0 to x600
        draw skip dx=0 dy=-elevation difference to existing ground
        mark x606 y606
        draw text char = ^DWT^ "~search text symbology"
        draw skip dx=0 dy=-_d_driveway_thickness
        mark x607 y607
        set plot parameters "~top driveway Symbology"
        draw skip to x1 y1
        draw to x602 y602
        draw to x604 y604
        draw to x606 y606
        set plot parameters "~bottom driveway Symbology"
        draw to x607 y607
        draw to x605 y605
        draw to x603 y603
        draw to x2 y2
      } 
    else               /*  _s_Sidewalk_case = ^None^   NEITHER FRONT NOR BACK PRESENT  */
      {
        draw skip dx=0 dy=4/12
        draw skip slope = "Green Space Slope" for dx = 10
        mark x602 y602
        draw text char = ^SWF^ "~search text symbology"
        draw skip dx=0 dy=-_d_driveway_thickness
        mark x603 y603
        draw skip to x602 y602
        draw skip slope = "Sidewalk Slope" for dx= 4
        mark x604 y604
        draw text char = ^SWB^ "~search text symbology"
        draw skip dx=0 dy=-_d_driveway_thickness
        mark x605 y605
        draw skip to x604 y604
        draw skip dx=1 dy=0 to x600
        draw skip dx=0 dy=-elevation difference to existing ground
        mark x606 y606
        draw text char = ^DWT^ "~search text symbology"
        draw skip dx=0 dy=-_d_driveway_thickness
        mark x607 y607
        set plot parameters "~top driveway Symbology"
        draw skip to x1 y1
        draw to x602 y602
        draw to x604 y604
        draw to x606 y606
        set plot parameters "~bottom driveway Symbology"
        draw to x607 y607
        draw to x605 y605
        draw to x603 y603
        draw to x2 y2
      }  
    draw slope text between x606 y606 and x604 y604 "~driveway slope text symbology"
    draw slope text between x604 y604 and x602 y602 "~driveway slope text symbology"
    draw slope text between x602 y602 and x1 y1 "~driveway slope text symbology"
    
    
       
  }




