/* Draws Median

Written: April, 2003

Modified:

Point range  400 - 450

Left side of median marks odd points
Right side marks even points and does the drawing

Median width of less than or equal to 1' results in undivided roadway

****************************************************************************/

/*  CHECK TO SEE IF MOW STRIP ELEMENTS ARE PRESENT  */
   
if intersect dgn = "~MS" within distance = 3 then
  {
    _s_Mow_Strip = ^Yes^ 
  }

if _s_skew_set = ^BOC^ then
  {
    if px1 > px2 and median width < 1000 then   /*  on right side of cluster (left side of median)and in median  */
      /*  LEFT SIDE OF MEDIAN MARKS POINTS ONLY  */
      {
        mark x431 y431
        draw skip dx=0 dy=(0.5/12)
        mark x401 y401                      /*  INSIDE EDGE OF MOW STRIP  */
        mark x403 y403
        if _s_mow_strip = ^yes^ then
          {
            draw skip slope = 6 to "~MS"
            mark x403 y403                   /* OUTSIDE EDGE OF MOW STRIP  */
            draw skip to x401 y401     
          }
          draw skip slope = 6 for dx = 10
        mark x405 y405
         
      }
    if px1 < px2 and median width < 1000 then   /*  on left side of cluster (right side of median)and in median  */
      {
        mark x432 y432
        draw skip dx=0 dy=(0.5/12)
        mark x402 y402                    /*  INSIDE EDGE OF MOW STRIP  */
        mark x406 y406
        if _s_mow_strip = ^yes^ then
          {
            draw skip slope = 6 to "~MS"
            mark x406 y406                    /* OUTSIDE EDGE OF MOW STRIP  */
            draw skip to x402 y402     
          }
        draw skip slope = 6 to intersection x401 y401 x405 y405
        mark x404 y404                        /*  INTERSECTION POINT  */
        _s_mow_strip_right = ^No^
        _s_mow_strip_left = ^No^
        
        if abs(x406 - x402) > tolerance then      /*  MOW STRIP EXISTS ON RIGHT SIDE OF MEDIAN  */
          {
            _s_mow_strip_right = ^Yes^
          }
        if abs(x401 - x403) > tolerance then      /*  MOW STRIP EXISTS ON LEFT SIDE OF MEDIAN  */
          {
            _s_mow_strip_left = ^Yes^
          }  
        
        
        
        if abs(x402 - x404) < abs(x402 - x403) and abs(x402 - x404) > abs(x402 - x406) then   
              /*  INTERSECTION POINT IS BETWEEN CURBS OR MOW STRIPS  */
          {
            draw skip to x404 y404 
            if _s_mow_strip_left = ^yes^ then
              { 
                set plot parameters "~slope symbology"
                draw to x403 y403
                set plot parameters "~mow strip symbology"
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x420 y420
                draw skip to x403 y403
                draw to x401 y401
                draw to x431 y431
                draw skip to x401 y401
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x411 y411
                draw skip to x431 y431
                set plot parameters "~bottom mow strip symbology"
                draw to x411 y411
                draw to x420 y420
                draw to x403 y403
              }
            else
              {
                set plot parameters "~mow strip symbology"
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x420 y420
                draw skip to x404 y404
                draw to x401 y401
                draw to x431 y431
                draw skip to x401 y401
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x411 y411
                draw skip to x431 y431
                set plot parameters "~bottom mow strip symbology"
                draw to x411 y411
                draw to x420 y420
              }  
              
              
              
              
            draw skip to x404 y404
            if _s_mow_strip_right = ^yes^ then
              { 
                set plot parameters "~slope symbology"
                draw to x406 y406
                set plot parameters "~mow strip symbology"
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x420 y420
                draw skip to x406 y406
                draw to x402 y402
                draw to x432 y432
                draw skip to x402 y402
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x412 y412
                draw skip to x432 y432
                set plot parameters "~bottom mow strip symbology"
                draw to x412 y412
                draw to x420 y420
                draw to x406 y406
              }
            else
              {
                set plot parameters "~mow strip symbology"
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x420 y420
                draw skip to x404 y404
                draw to x402 y402
                draw to x432 y432
                draw skip to x402 y402
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x412 y412
                draw skip to x432 y432
                set plot parameters "~bottom mow strip symbology"
                draw to x412 y412
                draw to x420 y420
              }  
              
          }  
        else                    /*  INTERSECTION POINT IS NOT BETWEEN CURBS OR MOW STRIPS  */
          {
            _d_run = abs(x432 - x431)
            _d_rise = (y431 - y432)
            _d_slope = (_d_rise/_d_run)*100
            
            draw skip to x432 y432
            if _s_mow_strip_left = ^Yes^ and _s_mow_strip_right = ^yes^ then
              {
                call sub draw_mow_strip_right
                call sub draw_mow_strip_left
              }
            else if _s_mow_strip_left = ^Yes^ and _s_mow_strip_right = ^no^ then 
              {
                call sub draw_mow_strip_left
              }
            else if _s_mow_strip_left = ^no^ and _s_mow_strip_right = ^yes^ then 
              {
                call sub draw_mow_strip_right
                set plot parameters "~slope symbology"
                draw to x431 y431
              }
            else
              {
                set plot parameters "~mow strip symbology"
                draw to x402 y402
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x420 y420
                draw skip to x402 y402
                draw to x401 y401
                draw to x431 y431
                draw skip to x401 y401
                set plot parameters "~bottom mow strip symbology"
                draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
                mark x422 y422
                draw skip to x431 y431
                draw to x422 y422
                draw to x420 y420 
                draw to x432 y432
              }    
          }
      }
  }



  
  
  
subroutine draw_mow_strip_right  
{
  set plot parameters "~mow strip symbology"
  draw to x402 y402
  draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
  mark x420 y420
  draw skip to x402 y402
  draw slope = _d_slope to x406
  mark x406 y406
  set plot parameters "~bottom mow strip symbology"
  draw dx=0 dy=-abs("Mow Strip Pave Thickness")
  draw to x420 y420
  draw to x432 y432
  draw skip to x406 y406
}  
end subroutine  
  
  
subroutine draw_mow_strip_left  
{
  set plot parameters "~slope symbology"
  draw slope = _d_slope to x403
  mark x403 y403
  draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
  mark x420 y420
  draw skip to x403 y403
  set plot parameters "~mow strip symbology"
  draw to x401 y401
  draw to x431 y431
  draw skip to x401 y401
  draw skip dx=0 dy=-abs("Mow Strip Pave Thickness")
  mark x422 y422
  draw skip to x431 y431
  set plot parameters "~bottom mow strip symbology"
  draw to x422 y422
  draw to x420 y420
  draw to x403 y403
}
end subroutine    
  
  
  
  
  
