/* Draws the pavement and courses

WRITTEN: April, 2003


Supports Automatic Pavement Widening

Point range  200-299

=================================================================================================*/




/*       The following two variables could be exposed and added to the variables   */
/*       file if it is ever nessesary to show multiple layers of pavement.         */
/*       any value greater than 0 cause a layer to be drawn.                       */

define "~Intermediate Course" 0
define "~Modified Subbase" 0


if p1 then
  {
   _d_txoff = 0.2*"xs scale"  /*  pgl text vertical offset-distance from the pavement to the text  */
   _d_cw = 1                  /*  width of curb */
   _d_pglel = ypgl
   _s_pglel = "PGL " + cvt_d_s2(_d_pglel)
   _d_bud = 0.5 /*  backup distance when inlet is encountered */
   _d_intersection = 0      /* INITIALIZE INTERSECTION FLAG  */
   _s_skew_set = "none"
   draw skip trace out offset = 0 for dx = 1000
   draw skip dx=-1 dy=0 to chain "Baseline Name"
   mark x80 y80
   call sub reset_skew
  }


/* THIS PART ADDED TO PLACE PGL TEXT AT PROPER LOCATION */
if px1 < px2 then
  {
    draw skip to xpgl ypgl
    draw skip dx=0 dy=_d_txoff
    draw text value = _s_pglel
    "~pgl elev text symbology"
  }  

/* THE PAVEMENT LAYERS ARE ALL DRAWN FROM THE LEFT SIDE */
if px1 < px2 then
  {
     /* SET UP VARIABLES FOR LATER USE */
     _d_draw = 0
     _d_counter = 1
     _d_layer = 721
     _d_thickness = 0
     _d_point = 501
     _d_total_pmp = number of pavement points


     remove skew effect

     /* MARK ALL BREAKS IN THE PAVEMENT */
     _d_pmp = 1
     _d_tmp = 700
     while _d_pmp <= _d_total_pmp
       {
         draw skip to p[_d_pmp]
         mark x[_d_tmp] y[_d_tmp]
         _d_pmp = _d_pmp + 1
         _d_tmp = _d_tmp + 1
       }
     /* EXTEND PAVEMENT TO GRAPHICAL ELEMENTS  */
     draw skip to p1
     mark x1 y1
     set plot parameters "~top pavement symbology"
     
     
     if median width < 1000 and median width > 12 then  /* IN MEDIAN SITUATION NOT IN A TAPER */
          {                                                /*  DEFINE DISTANCE TO SCAN FOR GRAPHICAL ELEMENTS  */
            _d_sd = 30 
          }
     else if median width < 12 then  /* IN A TAPER SITUATION */
          {                                                /*  DEFINE DISTANCE TO SCAN FOR GRAPHICAL ELEMENTS  */
            _d_sd = median width 
          }   
          
     else         /* ON OUTSIDE  */
          {
            _d_sd = 100
          }
          
          
     if (intersect dgn = "~EOP" within distance = _d_sd) then   /*  IF EOP IS FOUND  */
          {
            _s_skew_set = "EOP"
            if station within profile = "eop profile left" and median width > 1000 then   /* DON'T USE PROFILE IN MEDIAN  */
                {
                  draw skip slope = 0 to "~EOP"
                  draw skip dx=0 dy=100
                  draw skip dx=0 dy=-1 to prof elev = "eop profile left"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                  draw to p1
                }
              else
                {
                  draw slope = -1*(pavement slope) to "~EOP"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                }
          }
          
        else if (intersect dgn = "~BOC" within distance = _d_sd) then   /*  IF BOC IS FOUND  */
          {
            _s_skew_set = "BOC"
            if station within profile = "eop profile left" and median width > 1000 then   /* DON'T USE PROFILE IN MEDIAN  */
                {
                  draw skip slope = 0 to "~BOC"
                  draw skip dx=0 dy=100
                  draw skip dx=0 dy=-1 to prof elev = "eop profile left"
                  draw text char = BOC "~search text symbology"
                  mark x699 y699 
                  mark x220 y220
                  draw skip slope = ((y1-y699)/abs(x1-x699)) for dx = -1
                  mark x1 y1
                  draw text char = GUTTER "~search text symbology"
                  mark x699 y699 
                  mark x220 y220
                  draw to p1
                }
              else
                {
                  draw skip slope = -1*(pavement slope) to "~BOC"
                  
                  draw text char = BOC "~search text symbology"
                  draw skip slope = pavement slope for dx=-1
                  draw text char = GUTTER "~search text symbology"
                  mark x699 y699 
                  mark x220 y220
                  draw skip to x1 y1
                  draw to x699 y699
                  mark x1 y1
                }
          }  
   
      else if (intersect dgn = "~IRL" within distance = _d_sd) then   /*  IF INTERSECTION RETURN LINE IS FOUND  */
          {
            _s_skew_set = ^IRL^
            if station within profile = "eop profile left" and median width > 1000 then   /* DON'T USE PROFILE IN MEDIAN  */
                {
                  draw skip slope = 0 to "~IRL"
                  draw skip dx=0 dy=100
                  draw skip dx=0 dy=-1 to prof elev = "eop profile left"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                  draw to p1
                }
              else
                {
                  draw slope = -1*(pavement slope) to "~IRL"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                }
          }
      
      
      else if median width < 1000 then  /*  IN MEDIAN BUT NO GRAPHICAL ELEMENTS, MUST BE IN INTERSECTION */
          {
              /*   draw slope = -pavement slope to middle of median  */
            _s_skew_set = "none"
            mark x801 y801
            draw slope = -pavement slope for dx = (median width / 2)
            mark x699 y699 
            mark x220 y220
            mark x1 y1
            _d_intersection = 1        /*  SET FLAG TO TELL MEDIAN FILE THAT THIS IS IN INTERSECTION  */
          }

      else
          {
            _s_skew_set = "none"
            mark x1 y1
            draw text char = EOP "~search text symbology"
            mark x699 y699 
            mark x220 y220
          }

     draw skip to x1 y1


     /* END EXTEND PAVEMENT TO GRAPHICAL ELEMENTS  */


     while _d_counter <= 3
        {
           /* SET THICKNESS AND PLOT PARAMETERS FOR EACH LAYER */
           if _d_counter = 1 then
             {
               set plot parameters "~Bottom pavement symbology"
               _d_tmp_thickness = _d_thickness
               _d_thickness = _d_thickness + "Pavement Thickness"
               /* DETERMINES IF THE THICKNESS WAS 0 */
               if not _d_tmp_thickness = _d_thickness then
                 {
                   draw skip to x1 y1
                   draw skip dx=0 dy=-1 * _d_thickness
                   mark x225 y225
                   _d_draw = 1
                 }
               else
                 {
                   _d_draw = 0
                 }
             }
           else if _d_counter = 2 then
             {
               set plot parameters "~intermediate course symbology"
               _d_tmp_thickness = _d_thickness
               _d_thickness = _d_thickness + "~Intermediate Course"
               /* DETERMINES IF THE THICKNESS WAS 0 */
               if not _d_tmp_thickness = _d_thickness then
                 _d_draw = 1
               else
                 _d_draw = 0

             }
           else if _d_counter = 3 then
             {
               set plot parameters "~modified subbase symbology"
               _d_tmp_thickness = _d_thickness
               _d_thickness = _d_thickness + "~Modified Subbase"
               /* DRAWS modified subbase REGARDLESS OF THICKNESS */
               
             }

            _d_pmp = 1
            _d_tmp = 699
            draw skip to x1 y1
            draw skip dx=0 dy=-1 * _d_thickness
            mark x[_d_point] y[_d_point]
            mark x221 y221
            mark x222 y222
            _d_point = _d_point + 1
            if _d_counter = 2 then
              {
                mark x223 y223
              }
            while _d_pmp <= _d_total_pmp and _d_draw = 1
              {
                if _d_tmp = 699 and abs(x699 - x700) > tolerance then
                  {
                    draw dx= -1 * abs(x[_d_tmp] - x[_d_tmp + 1]) dy = y[_d_tmp + 1] - y[_d_tmp] to x[_d_tmp+1]
                  }
                else if NOT (_d_tmp = 699) then
                  {
                    draw dx= -1 * abs(x[_d_tmp] - x[_d_tmp + 1]) dy = y[_d_tmp + 1] - y[_d_tmp] to x[_d_tmp+1]
                  }
                _d_pmp = _d_pmp + 1
                _d_tmp = _d_tmp + 1
              }
            mark x[_d_layer] y[_d_layer]
            _d_layer = _d_layer + 1
            _d_counter = _d_counter + 1
        }

      draw skip to x1 y1
      mark x224 y224

  }

/* THE RIGHT SIDE GOES THRU THE MOTIONS BUT ONLY MARKS POINTS */
else if px1 > px2 then
  {
     _d_draw = 0
     _d_counter = 1
     _d_thickness = 0
     _d_point = 501
     _d_total_pmp = number of pavement points
     _d_pmp = 1
     _d_tmp = 700
     while _d_pmp <= _d_total_pmp
       {
         draw skip to p[_d_pmp]
         mark x[_d_tmp] y[_d_tmp]
         _d_tmp = _d_tmp + 1
         _d_pmp = _d_pmp + 1
       }
     /* EXTEND PAVEMENT TO GRAPHICAL ELEMENTS  */
     draw skip to p1
     mark x1 y1
     mark x229 y229
     set plot parameters "~top pavement symbology"
     
     
     if median width < 1000 and median width > 12 then  /* IN MEDIAN SITUATION NOT IN A TAPER */
          {                                                /*  DEFINE DISTANCE TO SCAN FOR GRAPHICAL ELEMENTS  */
            _d_sd = 30
          }
     else if median width < 12 then  /* IN A TAPER SITUATION */
          {                                                /*  DEFINE DISTANCE TO SCAN FOR GRAPHICAL ELEMENTS  */
            _d_sd = median width 
          }   
          
     else         /* ON OUTSIDE  */
          {
            _d_sd = 100
          }
          
     if (intersect dgn = "~EOP" within distance = _d_sd) then
          {
            _s_skew_set = "EOP"
            if station within profile = "eop profile right" and median width > 1000 then   /* DON'T USE PROFILE IN MEDIAN  */
                {
                  draw skip slope = 0 to "~EOP"
                  draw skip dx=0 dy=100
                  draw skip dx=0 dy=-1 to prof elev = "eop profile left"
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                  draw to p1
                }
              else
                {
                  draw slope = -pavement slope to "~EOP"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                }
          }
     
     else if (intersect dgn = "~BOC" within distance = _d_sd) then
          {
            _s_skew_set = "BOC"
            if station within profile = "eop profile right" and median width > 1000 then   /* DON'T USE PROFILE IN MEDIAN  */
                {
                  draw skip slope = 0 to "~BOC"
                  draw skip dx=0 dy=100
                  draw skip dx=0 dy=-1 to prof elev = "eop profile left"
                  draw text char = BOC "~search text symbology"
                  mark x699 y699 
                  mark x220 y220
                  draw skip slope = ((y1-y699)/abs(x1-x699)) for dx = -1
                  mark x1 y1
                  draw text char = GUTTER "~search text symbology"
                  mark x699 y699 
                  mark x220 y220
                  draw to p1
                }
              else
                {
                  draw skip slope = -pavement slope to "~BOC"
                  draw text char = BOC "~search text symbology"
                  draw skip slope = pavement slope for dx=-1
                  draw text char = GUTTER "~search text symbology"
                  mark x699 y699 
                  mark x220 y220
                  draw skip to x1 y1
                  draw to x699 y699
                  mark x1 y1
                }
          }
     
     else if (intersect dgn = "~IRL" within distance = _d_sd) then   /*  IF INTERSECTION RETURN LINE IS FOUND  */
          {
            _s_skew_set = "IRL"
            if station within profile = "eop profile left" and median width > 1000 then   /* DON'T USE PROFILE IN MEDIAN  */
                {
                  draw skip slope = 0 to "~IRL"
                  draw skip dx=0 dy=100
                  draw skip dx=0 dy=-1 to prof elev = "eop profile left"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                  draw to p1
                }
              else
                {
                  draw slope = -1*(pavement slope) to "~IRL"
                  mark x1 y1
                  mark x699 y699 
                  mark x220 y220
                  draw text char = EOP "~search text symbology"
                }
          }
     
        
     
     draw skip to x1 y1     


     else if median width < 1000 then  /*  IN MEDIAN BUT NO GRAPHICAL ELEMENTS, MUST BE IN INTERSECTION */
          {
            draw slope = -pavement slope for dx = (median width /2)
            mark x800 y800
            mark x699 y699 
            mark x220 y220
            mark x1 y1
            _d_intersection = 1        /*  SET FLAG TO TELL MEDIAN FILE THAT THIS IS IN INTERSECTION  */
          }
          
     else              /*  no DGn elements, use edge of shape as EOP  */
          {
            _s_skew_set = "none"
            mark x1 y1
            draw text char = EOP "~search text symbology"
            mark x699 y699 
            mark x220 y220
          }     
          
     draw skip to x1 y1


     /* END EXTEND PAVEMENT TO GRAPHICAL ELEMENTS  */

     _d_layer = 721
     while _d_counter <= 3
        {
           /* SET THICKNESS AND PLOT PARAMETERS FOR EACH LAYER */
           if _d_counter = 1 then
             {
               set plot parameters "~bottom pavement symbology"
               _d_tmp_thickness = _d_thickness
               _d_thickness = _d_thickness + "Pavement Thickness"
               if not _d_tmp_thickness = _d_thickness then
                 {
                   draw skip to x1 y1
                   draw skip dx=0 dy=-1 * _d_thickness
                   mark x225 y225
                   _d_draw = 1
                 }
               else
                 {
                   _d_draw = 0
                 }
             }
           else if _d_counter = 2 then
             {
               set plot parameters "~intermediate course symbology"
               _d_tmp_thickness = _d_thickness
               _d_thickness = _d_thickness + "~Intermediate Course"
               if "~Intermediate Course" > 0 then
                 {
                   _d_draw = 1
                 }
               else
                 {
                   _d_draw = 0
                 }
             }
           else if _d_counter = 3 then
             {
               set plot parameters "~modified subbase symbology"
               _d_tmp_thickness = _d_thickness
               _d_thickness = _d_thickness + "~Modified Subbase"
              
             }

            _d_pmp = 1
            _d_tmp = 699
            draw skip to x1 y1
            draw skip dx=0 dy=-1 * _d_thickness
            mark x222 y222
            mark x[_d_point] y[_d_point]
            _d_point = _d_point + 1
            
            if _d_counter = 2 then
              {
                mark x223 y223
              }
            
            if _d_draw = 1 then
              {
                draw to x[_d_layer] y[_d_layer]
              }
            while _d_pmp <= _d_total_pmp and _d_draw = 1
              {
                if _d_tmp = 699 and abs(x699 - x700) > tolerance then
                  {
                    draw dx= -1 * abs(x[_d_tmp] - x[_d_tmp + 1]) dy = y[_d_tmp + 1] - y[_d_tmp] to x[_d_tmp+1]
                  }
                else if NOT (_d_tmp = 699) then
                  {
                    draw skip dx= -1 * abs(x[_d_tmp] - x[_d_tmp + 1]) dy = y[_d_tmp + 1] - y[_d_tmp] to x[_d_tmp+1]
                  }
                _d_pmp = _d_pmp + 1
                _d_tmp = _d_tmp + 1
              }

            _d_counter = _d_counter + 1
            _d_layer = _d_layer + 1
        }
      draw skip to x222 y222
      mark x228 y228
       if px1>px2 then
        {
          draw skip slope = pave slope for dx=-3
          mark x227 y227
        }
      draw skip to x1 y1
      mark x224 y224
      if (abs(x229-x699) < tolerance) then
        {
          _d_subgrade_slope = -pave slope
        }
      else 
        {
          _d_subgrade_slope = -((y229-y699)/abs(x229-x699))*100
        }
  
 
 }

if p1 then
 {
 add skew effect 
 call sub reset_skew
 }



/* end of file */






