/* Draws the Sideslopes behind curb

WRITTEN: April, 2003


Point range  300 - 350

300 Front of sidewalk
301 Back of sidewalk
302 Sub Back of sidewalk
305 Sidewalk tie down
306 Sub Sidewalk tie down

=================================================================================================*/

if not (_s_skew_set = ^IRL^) and (_s_driveway = ^no^) then
  {

    if p1 then
      {
        mark x1 y1
        _s_Sidewalk_case = ^undefined^
                  
        /*  DRAW THE SIDESLOPES  */  
        
        if _s_Front_Path = ^no^ and _s_Back_Path = ^yes^ then  /* ONLY BACK PRESENT  */
          {
            _s_Sidewalk_case = ^Back Only^
            mark x300 y300
            draw text char = ^SWF^ "~search text symbology"
            set plot parameters "~sidewalk symbology"
            draw slope = "sidewalk slope" to x301
            mark x301 y301
            draw text char = ^SWB^ "~search text symbology"
            set plot parameters "~bottom sidewalk symbology"
            if _s_Path_tie = ^no^ then
              {
                draw dx=0 dy=-(_d_Path_thickness)
              }
            else
              {
                draw skip dx=0 dy=-(_d_Path_thickness)
              }
            mark x302 y302
            draw slope = -"sidewalk slope" to x300
            draw to x300 y300
            draw skip to x301 y301
            call sub reset_skew
            set plot parameters "~slope symbology"
            if (_s_hingepoint = ^no^) then                    /*  NO GRAPHICAL HINGE POINT  */
              {
                draw slope = "green space slope" for dx="Minimum sidewalk Ext."
              }  
            else if (abs(x80 - x330) < abs(x80- x301)) then   /*  HINGE POINT IS NOT BEYOND BACK OF SIDEWALK   */
              {
                draw slope = "green space slope" for dx="Minimum sidewalk Ext."
              }
            else                                              /*  HINGE POINT IS BEYOND SIDEWALK, DRAW TO IT  */
              {
                draw slope = "green space slope" to x330
              }    
            mark x310 y310
            call sub hinge_point
          }  
        else if _s_Front_Path = ^YES^ and _s_Back_Path = ^no^ then   /* ONLY FRONT PRESENT  */
          {
            _s_Sidewalk_case = ^Front Only^
            draw text char = ^found front only^  "~warning text symbology"
          }  
        else if _s_Front_Path = ^YES^ and _s_Back_Path = ^YES^ then  /* BOTH Front & Back PRESENT  */
          {
            _s_Sidewalk_case = ^Front & Back^
            set plot parameters "~slope symbology"
            draw slope = "green space slope" to x300
            mark x300 y300
            draw text char = ^SWF^ "~search text symbology"
            set plot parameters "~sidewalk symbology"
            draw slope = "sidewalk slope" to x301
            mark x301 y301
            draw text char = ^SWB^ "~search text symbology"
            set plot parameters "~bottom sidewalk symbology"
            if _s_Path_tie = ^no^ then
              {
                draw dx=0 dy=-(_d_Path_thickness)
              }
            else
              {
                draw skip dx=0 dy=-(_d_Path_thickness)
              }
            mark x302 y302
            draw slope = -"sidewalk slope" to x300
            draw to x300 y300
            draw skip to x301 y301
            call sub reset_skew
            if _s_Path_tie = ^no^ then       /*  there is no sidewalk tie line present  */
              {
                set plot parameters "~slope symbology"
                if (_s_hingepoint = ^no^) then                    /*  NO GRAPHICAL HINGE POINT  */
                  {
                    draw slope = "green space slope" for dx="Minimum sidewalk Ext."
                  }  
                else if (abs(x80 - x330) < abs(x80- x301)) then   /*  HINGE POINT IS NOT BEYOND BACK OF SIDEWALK   */
                  {
                    draw slope = "green space slope" for dx="Minimum sidewalk Ext."
                  }
                else                                              /*  HINGE POINT IS BEYOND SIDEWALK, DRAW TO IT  */
                  {
                    draw slope = "green space slope" to x330
                  }    
                mark x310 y310
                call sub hinge_point
              }
            else                                 /*  THERE IS A SIDEWALK TIE LINE PRESENT, TIE TO EXISTING GROUND */
              {
                set plot parameters "~sidewalk symbology"  
                draw skip to x305 y305
                draw skip dx=0 dy=-elevation difference to existing ground
                mark x305 y305
                draw to x301 y301
                draw skip to x305 y305
                set plot parameters "~bottom sidewalk symbology"  
                draw dx = 0 dy = -_d_Path_thickness
                mark x306 y306
                mark x310 y310
                mark x320 y320
                draw to x302 y302
                draw skip to x320 y320
              }
          }
        else                                        /* NEITHER FRONT NOR BACK PRESENT  */
          {
            _s_Sidewalk_case = ^None^
            set plot parameters "~slope symbology"
            if intersect dgn = "~HP" then
              {
                draw slope = "Green space slope" to "~HP"
              }
            else
              {
                draw slope = "green space slope" for dx="Minimum Greenspace width"
              }
             mark x310 y310
             call sub hinge_point
          }   
         if _s_Path_tie = ^no^ then        /*  DRAW SIDESLOPES   */           
           {
             draw skip to x310 y310
             set plot parameters "~slope symbology"
             if elevation difference >= 0 then
               {
                 draw slope = _d_foreslope:-1 to existing ground
               }
             else
               {
                 draw slope = _d_backslope:1 to existing ground
               }
             mark x320 y320
             if abs(x320 - x310) > tolerance then     /* TIED TO EXISTING GROUND  */
               {
                 draw text char = ^CATCH^ "~search text symbology"
                 draw slope text between x310 y310 and x320 y320 "~slope text symbology"
                 call sub catch_point
               }
             else
               {
                 draw text char = ^COULD NOT TIE TO EXISTING^ "~Warning Text Symbology"
               }
           }     
      }
    
    if not _s_Sidewalk_case = ^undefined^ then
      {
        if _s_Sidewalk_case = ^Back Only^ then             /* ONLY BACK PRESENT  */
          {
          /*  draw slope text between x300 y300 and x301 y301 "~slope text symbology" */
          /*  draw slope text between x301 y301 and x310 y310 "~slope text symbology" */
          }
        if _s_Sidewalk_case = ^Front Only^ then             /* ONLY FRONT PRESENT  */
          {
          /*  draw skip dx=0 dy=0 */        /* DO NOTHING  */
          }  
        if _s_Sidewalk_case = ^Front & Back^ then
          {
          /*  draw slope text between x1 y1 and x300 y300 "~slope text symbology"    */
          /*  draw slope text between x300 y300 and x301 y301 "~slope text symbology"*/ 
          /*  draw slope text between x301 y301 and x310 y310 "~slope text symbology"*/
          } 
        if _s_Sidewalk_case = ^None^ then             /* NEITHER FRONT NOR BACK PRESENT  */
          {
          /*  draw slope text between x1 y1 and x310 y310 "~slope text symbology"*/
          }   
            
          
      }
      
  }      
else if _s_skew_set = ^IRL^ then
  {
    set plot parameters "~slope symbology"
    draw dx=0 dy=-elevation difference to existing ground
    mark x310 y310
  }

