/*  Subroutines  */




/*===============================================================================================*/
/*===========SUBROUTINE - ASSEMBLES THE OFFSET AND ELEVATION LABEL  =============================*/
/*===========  OFFSET IS 2 DEC   ================================================================*/
/*===============================================================================================*/
subroutine offset_elevation     
  {
    mark x345 y345
    _d_off = abs(x345 - x80)
    _d_elev = abs(y345)
    if x345 < x80 then
     {
      _s_side = "Lt."
     }
   else
     {
      _s_side = "Rt."
     }  
    _s_label = cvt_d_s2(_d_off) + " " + _s_side + ", El. " + cvt_d_s2(_d_elev)
        
    draw skip dx=0 dy = _d_txoff
    draw text value=_s_label
       "~offset text symbology"
    draw skip to x345 y345
  }
end sub

/*===============================================================================================*/
/*===========SUBROUTINE - ASSEMBLES THE HINGE POINT OFFSET AND ELEVATION LABEL  =================*/
/*===========  OFFSET AND ELEVATION IS 2 DEC   ==================================================*/
/*===============================================================================================*/
subroutine Hinge_Point     
  {
    mark x345 y345
    _d_off = abs(x345 - x80)
    _d_elev = abs(y345)
    if x345 < x80 then
     {
      _s_side = "Lt."
     }
   else
     {
      _s_side = "Rt."
     }  
      _s_label = "HP " + cvt_d_s2(_d_off) + ", " + cvt_d_s2(_d_elev)
    draw skip dx=0 dy = _d_txoff
    draw text value=_s_label
    "~HP text symbology"
    draw skip to x345 y345
  }
end sub


/*===============================================================================================*/
/*===========SUBROUTINE - ASSEMBLES THE CATCH POINT OFFSET AND ELEVATION LABEL  =================*/
/*===========  OFFSET AND ELEVATION IS 2 DEC   ==================================================*/
/*===============================================================================================*/
subroutine Catch_Point     
  {
    mark x345 y345
    _d_off = abs(x345 - x80)
    _d_elev = abs(y345)
    if x345 < x80 then
     {
      _s_side = "Lt."
     }
   else
     {
      _s_side = "Rt."
     }  
      _s_label = "CP " + cvt_d_s2(_d_off) + ", " + cvt_d_s2(_d_elev)
    draw skip dx=0 dy = _d_txoff
    draw text value=_s_label
    "~CP text symbology"
    draw skip to x345 y345
  }
end sub

/*===============================================================================================*/
/*===========SUBROUTINE - ASSEMBLES THE OFFSET LABLE ROUNDED TO 2 DEC  ==========================*/
/*===============================================================================================*/
subroutine offset_2            
  {
    mark x345 y345
    _d_off = abs(x345 - x80)
    _d_elev = abs(y345)
    if x345 < x80 then
     {
      _s_side = "Lt."
     }
   else
     {
      _s_side = "Rt."
     }  
   _s_label = cvt_d_s2(_d_off) + " " + _s_side
     
   draw skip dx=0 dy = _d_txoff
   draw text value=_s_label
      "~offset text symbology"
   draw skip to x345 y345
  }
end sub



/*===============================================================================================*/
/*===========SUBROUTINE - RESETS THE SKEW BACK TO THE ELEMENT THAT REPRESENTS THE EOP  =====================*/
/*===============================================================================================*/
sub reset_skew
{
  if not _s_skew_set = "none" then    /* if skew angle was set by some eop element, then */
    {
     set skew angle 0
     mark x345 y345
     draw skip to px1 py1
     draw skip dx=-2*tolerance dy=0
         
     if _s_skew_set = "EOP" then
       {
        draw skip dx=1 dy=0 to "~EOP"
       }
     else if _s_skew_set = "BOC" then
       {
        draw skip dx=1 dy=0 to "~BOC"
       }
     else if _s_skew_set = "IRL" then
       {
        draw skip dx=1 dy=0 to "~IRL"
       }  
     else
       {
        Prompt ^There is a problem with resetting the skew angle^ mode = message
            if (CANCEL) then {EXIT}
       }     
     draw skip to x345 y345
    }
 }
end sub
























