<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:inr="http://mycompany.com/mynamespace">
    <xsl:include href="../format.xsl"/>
    <xsl:param name="xslRootDirectory" select="inr:xslRootDirectory"/>
    <!-- Zeiss Export Format Report -->
    <xsl:output method="text" media-type="text/plain" encoding="iso-8859-1"/>
    <xsl:template match="/">
        <xsl:variable name="gridOut" select="inr:SetGridOut(number(InRoads/@outputGridScaleFactor))"/>
        <xsl:choose>
            <xsl:when test="$xslShowHelp = 'true'">
                <xsl:call-template name="StyleSheetHelp"/>
            </xsl:when>
            <xsl:otherwise>
                <xsl:for-each select="InRoads/SurveyFieldbook/SurveyPointList">
                    <xsl:text/>
                    <xsl:for-each select="SurveyPoint">
                        <xsl:text>&#xa0;      &#xa0;</xsl:text>
                        <xsl:choose>
                            <xsl:when test="string-length(@name) &gt; 6">
                                <xsl:value-of select="substring(@name, (string-length(@name) - 5), 6)"/>
                            </xsl:when>
                            <xsl:when test="string-length(@name) &lt; 6">
                                <xsl:value-of select="@name"/>
                                <xsl:value-of select="substring('      ', 1, (6 - string-length(@name)))"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="@name"/>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:choose>
                            <xsl:when test="string-length(@code) &gt; 21">
                                <xsl:value-of select="substring(@code, (string-length(@code) - 20), 21)"/>
                            </xsl:when>
                            <xsl:when test="string-length(@code) &lt; 21">
                                <xsl:value-of select="@code"/>
                                <xsl:value-of select="substring('                     ', 1, (21 - string-length(@code)))"/>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="@code"/>
                            </xsl:otherwise>
                        </xsl:choose>
                        <xsl:text> X </xsl:text>
                        <xsl:value-of select="inr:columnDoubleFormat(number(@easting), 4, 12)"/>
                        <xsl:text> Y </xsl:text>
                        <xsl:value-of select="inr:columnDoubleFormat(number(@northing), 4, 13)"/>
                        <xsl:text> Z </xsl:text>
                        <xsl:value-of select="inr:columnDoubleFormat(number(@elevation), 4, 9)"/>
                        <xsl:text>&#xd;</xsl:text>
                    </xsl:for-each>
                </xsl:for-each>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="StyleSheetHelp">
        <xsl:text>Notes&#xd;&#xd;</xsl:text>
        <xsl:text>    You must select at least one fieldbook in the Survey &gt;&#xd;</xsl:text>
        <xsl:text>    XML Report command to get results from this report.&#xd;&#xd;</xsl:text>
        <xsl:text>    Your fieldbook must contain data for a complete report.&#xd;&#xd;</xsl:text>
        <xsl:text>    This report emulates the Text Export Wizard called&#xd;</xsl:text>
        <xsl:text>    zeiss.tew.&#xd;&#xd;</xsl:text>
        <xsl:text>Copyright 2006 Bentley Systems, Inc&#xd;</xsl:text>
    </xsl:template>
</xsl:stylesheet>
